moSetGetInputOutputLs = {};

function moSetGetInputOutputLs:getPlaceable(self, objectTable)	
	local inputFillTypes={};
	local outputFillTypes={};	
	local container = 1;
	local ratio = 0;
	local productivity = 0;
	local productivityColor = moGuiMiniPdaSlots.warningColor0;
	local fillLevel = 0;
	local capacity = 0;
	local inputEmty = false;
	if objectTable ~= nil and objectTable.xmlFilename ~= nil and string.find(objectTable.xmlFilename, "greenhouse") then		
		local foundWaterFillLevel = false;
		if objectTable.waterTankCapacity ~= nil and objectTable.waterTankFillLevel ~= nil then				
			local info={};
			local fillType = Fillable.fillTypeNameToInt["water"];					
			info.capacity = objectTable.waterTankCapacity;
			info.fillLevel = objectTable.waterTankFillLevel;
			--if info.fillLevel > 0.1 then foundWaterFillLevel = true;end;
			if info.fillLevel <= 0.1 then inputEmty = true;end;
			if not inputEmty then
				fillLevel = fillLevel+info.fillLevel;
				capacity = capacity+info.capacity;
			end;
			--ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
			--if tonumber(productivity) >= tonumber(ratio) then
			--	productivity = tonumber(ratio);	
			--end;
			info.container = container;					
			info.fillTypeName = "";
			info.lengthFillTypes = 1;					
			inputFillTypes[container] = {};
			local pricePerLiter, fillTypeNameString = moSetGetInputOutputLs:getFillTypeStringName(self, fillType, info.fillTypeName, nil);					
			info.fillTypeName = fillTypeNameString;
			info.pricePerLiter = pricePerLiter;
			table.insert(inputFillTypes[container], info);
			container = container+1;
		end;
		local foundManureFillLevel = false;
		if objectTable.manureCapacity ~= nil and objectTable.manureFillLevel ~= nil then
			local info={};
			local fillType = Fillable.fillTypeNameToInt["manure"];
			info.capacity = objectTable.manureCapacity;
			info.fillLevel = objectTable.manureFillLevel;
			--if info.fillLevel > 0.1 then foundManureFillLevel = true;end;
			if info.fillLevel <= 0.1 then inputEmty = true;end;
			if not inputEmty then
				fillLevel = fillLevel+info.fillLevel;
				capacity = capacity+info.capacity;
			end;
			--ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
			--if tonumber(productivity) >= tonumber(ratio) then
			--	productivity = tonumber(ratio);	
			--end;
			info.container = container;					
			info.fillTypeName = "";
			info.lengthFillTypes = 1;					
			inputFillTypes[container] = {};
			local pricePerLiter, fillTypeNameString = moSetGetInputOutputLs:getFillTypeStringName(self, fillType, info.fillTypeName, nil);					
			info.fillTypeName = fillTypeNameString;
			info.pricePerLiter = pricePerLiter;
			table.insert(inputFillTypes[container], info);
			container = container+1;
		end;
		container = 1;
		function setIncomePerHour()
			local info = {};			
			info.fillTypeName = tostring(moLanguageXml:getTxt("greenhousels"));		
			info.lengthFillTypes = 1;		
			info.pricePerLiter = 0;
			if not inputEmpty then info.pricePerLiter = moGeneralSettings.difficultyMultiplier*Utils.getNoNil(objectTable.incomePerHour, 100);end;		
			info.fillLevel = 0;
			info.capacity = -2;		
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
		end;
		setIncomePerHour();	
		productivity = Utils.getNoNil(fillLevel/capacity*100, 0);
		if not inputEmty then
			if tonumber(productivity) <= 90 and tonumber(productivity) >= 75 then
				productivityColor = moGuiMiniPdaSlots.warningColor1;
			elseif tonumber(productivity) < 75 and tonumber(productivity) >= 50 then
				productivityColor = moGuiMiniPdaSlots.warningColor2;
			elseif tonumber(productivity) < 50 and tonumber(productivity) >= 25 then
				productivityColor = moGuiMiniPdaSlots.warningColor3;
			elseif tonumber(productivity) < 25 then
				productivityColor = moGuiMiniPdaSlots.warningColor4;
			end;
		else
			productivity = 0;
			productivityColor = moGuiMiniPdaSlots.warningColor4;			
		end;		
		outputFillTypes[1][1].productivity = productivity;
		outputFillTypes[1][1].productivityColor = productivityColor;
	end;		
	return inputFillTypes, outputFillTypes
end;

function moSetGetInputOutputLs:getAnimals(self, objectTable, xmlModString)
	local inputFillTypes={};
	local outputFillTypes={};	
	local container = 1;	
	function setAllValues()		
		local info = {};
		info.fillTypeName = tostring(moLanguageXml:getTxt(xmlModString)).. " ".. tostring(moLanguageXml:getTxt("amount", nil, "Amount"));		
		info.lengthFillTypes = 1;
		info.pricePerLiter = getAnimalStorePrice(self, objectTable.name);		
		info.fillLevel = Utils.getNoNil(objectTable.totalNumAnimals, 0);
		info.capacity = -1;
		info.productivity = string.format("%1.0f", Utils.getNoNil(objectTable.productivity*100, 0)); --Utils.getNoNil(objectTable.productivity*100, 0); --string.format("%0.0f", Utils.getNoNil(0, 0));
		info.productivityColor = getProductivityColor(self, info.productivity); --moGuiExtras.colors['green'];
		outputFillTypes[container] = {};
		table.insert(outputFillTypes[container], info);
		container = container+1;		
	end;
	if objectTable.name == "chicken" and objectTable.totalNumAnimals >= 2 then	
		setAllValues();		
		local info = {};
		info.fillLevel = Utils.getNoNil(g_currentMission:getSiloAmount(Fillable.FILLTYPE_EGG), 0);
		info.capacity = -1;
		info.pricePerLiter = getEggPrice(self, Fillable.FILLTYPE_EGG);
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_pickup", nil, "Pickup"));		
		info.lengthFillTypes = 1;
		outputFillTypes[container] = {};
		table.insert(outputFillTypes[container], info);
		container = container+1;
		local info = {};
		info.fillLevel = Utils.getNoNil(objectTable.numActivePickupObjects, 0);
		info.capacity = -1;
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_egg1", nil, "Eggs in the barn"));		
		info.lengthFillTypes = 1;
		info.setColor = moGuiMiniPdaSlots.warningColor0;
		local egg = tonumber(info.fillLevel);
		if egg >= 54 then info.setColor = moGuiMiniPdaSlots.warningColor3;end;
		if egg < 54 and egg >= 40 then info.setColor = moGuiMiniPdaSlots.warningColor2;end;
		if egg < 40 and egg >= 20 then info.setColor = moGuiMiniPdaSlots.warningColor1;end;
		info.pricePerLiter = 0;
		outputFillTypes[container] = {};
		table.insert(outputFillTypes[container], info);		
		container = 1;		
		if moGeneralSettings.watermod and moMapObjects.watermod[objectTable.name] ~= nil then
			for a=1, moMapObjects.watermod[objectTable.name].length do				
				local info = {};				
				info.capacity = 0;
				info.fillLevel = 0;
				info.pricePerLiter = 0;
				info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(moMapObjects.watermod[objectTable.name][a]), 0);
				local waterModFruitName = getWaterModFruitName(self, moMapObjects.watermod[objectTable.name][a]);
				local fillName = tostring(moLanguageXml:getTxt("a_foragemix", nil, "FeedTrog"))
				if string.find(waterModFruitName, "water") then fillName = tostring(moLanguageXml:getTxt("a_watertrough", nil, "WaterTrog"));end;
				if string.find(waterModFruitName, "wheat") then fillName = tostring(moLanguageXml:getTxt("a_wheattrough", nil, "WheatTrog"));end;
				info.fillTypeName = fillName;				
				info.lengthFillTypes = 1;
				inputFillTypes[container] = {};
				table.insert(inputFillTypes[container], info);
				container=container+1;				
			end;
		end;		
	end;	
	if objectTable.name == "sheep" and objectTable.totalNumAnimals >= 1 then	
		setAllValues();
		local info = {};
		info.fillLevel = 0;
		info.capacity = -1;
		info.pricePerLiter = getFruitPrice(self, Fillable.FILLTYPE_WOOL);
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_wool", nil, "Wool"));
		info.setColor = moGuiMiniPdaSlots.siloColor;
		info.lengthFillTypes = 1;
		if objectTable.currentPallet ~= nil then
			info.fillLevel = Utils.getNoNil(objectTable.currentPallet.fillLevel, 0);
			info.capacity = Utils.getNoNil(objectTable.currentPallet.capacity, 0);
			local checkCapacity = tonumber(info.fillLevel)/tonumber(info.capacity)*100;
			if checkCapacity >= 85 then info.setColor = moGuiMiniPdaSlots.warningColor3;end;
			if checkCapacity <= 85 and checkCapacity >= 50 then info.setColor = moGuiMiniPdaSlots.warningColor2;end;
			if checkCapacity <= 50 and checkCapacity >= 25 then info.setColor = moGuiMiniPdaSlots.warningColor0;end;
		end;		
		outputFillTypes[container] = {};
		table.insert(outputFillTypes[container], info);
		container = container+1;		
		if objectTable.palSammler ~= nil then
			for k, objectPal in pairs(objectTable.palSammler) do
				local info = {};
				info.capacity = 0;
				info.fillLevel = 0;
				info.container = container;					
				info.fillTypeName = moLanguageXml:getTxt("palsammler", nil, "PalCollector");
				info.lengthFillTypes = 1;
				info.pricePerLiter = 0;
				info.setColor = moGuiMiniPdaSlots.warningColor0
				local objCreate = objectTable.palSammler[k];			
				local fremdObj = objCreate.fremdObject;
				if fremdObj ~= nil and fremdObj > 0 then info.fillTypeName = moLanguageXml:getTxt("palsammlerblocked", nil, "Blocked !!");end;
				info.capacity = Utils.getNoNil(table.getn(objCreate.Points), 1);
				local noticePal = 0;
				if info.capacity > 1 then
					for i = 1, info.capacity do
						if objCreate.Points[i].Pallet ~= nil then
							noticePal = noticePal+1;					
						end;
					end;
				end;			
				info.fillLevel = info.fillLevel+noticePal;			
				if info.fillLevel >= info.capacity then info.setColor = moGuiMiniPdaSlots.warningColor4;end;
				if info.fillLevel >= info.capacity/2 and info.fillLevel < info.capacity then info.setColor = moGuiMiniPdaSlots.warningColor2;end;			
				outputFillTypes[container] = {};
				table.insert(outputFillTypes[container], info);
				container = container+1;
			end;
		end;
		container = 1;
		local info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(Fillable.FILLTYPE_FORAGE), 0)
		info.capacity = 0;
		info.pricePerLiter = 0;
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_foragemix", nil, "ForageMix"));		
		info.lengthFillTypes = 1;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		if moGeneralSettings.watermod and moMapObjects.watermod[objectTable.name] ~= nil then
			for a=1, moMapObjects.watermod[objectTable.name].length do				
				local info = {};				
				info.capacity = 0;
				info.pricePerLiter = 0;
				info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(moMapObjects.watermod[objectTable.name][a]), 0);
				local waterModFruitName = getWaterModFruitName(self, moMapObjects.watermod[objectTable.name][a]);
				local fillName = tostring(moLanguageXml:getTxt("a_foragemix", nil, "FeedTrog"))
				if string.find(waterModFruitName, "water") then fillName = tostring(moLanguageXml:getTxt("a_watertrough", nil, "WaterTrog"));end;
				if string.find(waterModFruitName, "wheat") then fillName = tostring(moLanguageXml:getTxt("a_wheattrough", nil, "WheatTrog"));end;
				info.fillTypeName = fillName;				
				info.lengthFillTypes = 1;
				inputFillTypes[container] = {};
				table.insert(inputFillTypes[container], info);
				container=container+1;				
			end;
		end;		
	end;	
	if objectTable.name == "cow" and objectTable.totalNumAnimals >= 1 then
		setAllValues();		
		local info = {};
		info.fillLevel = Utils.getNoNil(objectTable.fillLevelMilk, 0);
		info.capacity = 0;
		info.pricePerLiter = getFruitPrice(self, Fillable.FILLTYPE_MILK);
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_milk", nil, "Milk"));		
		info.lengthFillTypes = 1;
		outputFillTypes[container] = {};
		table.insert(outputFillTypes[container], info);
		container = container+1;
		if g_currentMission.triggerExtendSellMilk ~= nil or g_currentMission.orgFSsellMilk ~= nil and g_currentMission.orgFSsellMilk then
			local info = {};
			info.fillLevel = 0;
			info.capacity = -2;
			info.pricePerLiter = 0;
			info.fillTypeName = tostring(moLanguageXml:getTxt("a_milkbuy", nil, "AutoMilkBuy"));
			info.extraText = tostring(moLanguageXml:getTxt("off", nil, "Off"));
			info.setColor = moGuiMiniPdaSlots.warningColor3;		
			info.lengthFillTypes = 1;
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);
			container = container+1;
		end;
		local info = {};
		info.fillLevel = Utils.getNoNil(objectTable.manureHeap.fillLevel, 0);
		info.capacity = 0;
		info.pricePerLiter = getFruitPrice(self, Fillable.FILLTYPE_MANURE);
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_manure", nil, "Manure"));		
		info.lengthFillTypes = 1;
		outputFillTypes[container] = {};
		table.insert(outputFillTypes[container], info);
		container = container+1;
		local info = {};
		info.fillLevel = Utils.getNoNil(objectTable.liquidManureTrigger.fillLevel, 0);
		info.capacity = 0;
		info.pricePerLiter = getFruitPrice(self, Fillable.FILLTYPE_LIQUIDMANURE);
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_liquidmanure", nil, "LiquidManure"));		
		info.lengthFillTypes = 1;
		outputFillTypes[container] = {};
		table.insert(outputFillTypes[container], info);
		---input
		container = 1;
		local info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(Fillable.FILLTYPE_FORAGE), 0);
		info.capacity = 0;
		info.pricePerLiter = 0;
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_forage", nil, "Forage"));		
		info.lengthFillTypes = 1;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		local info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(Fillable.FILLTYPE_SILAGE), 0);
		info.capacity = 0;
		info.pricePerLiter = 0;
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_silage", nil, "Silage"));		
		info.lengthFillTypes = 1;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		local info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(Fillable.FILLTYPE_GRASS_WINDROW), 0);
		info.capacity = 0;
		info.pricePerLiter = 0;
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_gras", nil, "Gras"));		
		info.lengthFillTypes = 1;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		local info = {};
		info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(Fillable.FILLTYPE_WHEAT_WINDROW), 0);
		info.capacity = 0;
		info.pricePerLiter = 0;
		info.fillTypeName = tostring(moLanguageXml:getTxt("a_straw", nil, "Straw"));		
		info.lengthFillTypes = 1;
		inputFillTypes[container] = {};
		table.insert(inputFillTypes[container], info);
		container = container+1;
		if moGeneralSettings.watermod and moMapObjects.watermod[objectTable.name] ~= nil then
			for a=1, moMapObjects.watermod[objectTable.name].length do				
				local info = {};				
				info.capacity = 0;
				info.pricePerLiter = 0;
				info.fillLevel = Utils.getNoNil(objectTable:getFillLevel(moMapObjects.watermod[objectTable.name][a]), 0);
				local waterModFruitName = getWaterModFruitName(self, moMapObjects.watermod[objectTable.name][a]);				
				local fillName = tostring(moLanguageXml:getTxt("a_foragemix", nil, "FeedTrog"))
				if string.find(waterModFruitName, "water") then fillName = tostring(moLanguageXml:getTxt("a_watertrough", nil, "WaterTrog"));end;
				if string.find(waterModFruitName, "wheat") then fillName = tostring(moLanguageXml:getTxt("a_wheattrough", nil, "WheatTrog"));end;
				info.fillTypeName = fillName;				
				info.lengthFillTypes = 1;
				inputFillTypes[container] = {};
				table.insert(inputFillTypes[container], info);
				container=container+1;				
			end;
		end;		
	end;
	return inputFillTypes, outputFillTypes
end;

function moSetGetInputOutputLs:getFillTypeStringName(self, fillType, fillTypeNameString, fillTypeName)
	local pricePerLiter = 0;
	local stringName = fillTypeNameString;
	local desc = Fillable.fillTypeIndexToDesc[fillType];	
	if desc ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then								
		local bestPriceTemp = 1;
		if moFillTypes[desc.index].bestPrice ~= 0 then bestPriceTemp = moFillTypes[desc.index].bestPrice;end;
		pricePerLiter = moFillTypes[desc.index].pricePerLiter*bestPriceTemp*moGeneralSettings.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;		
		if not string.find(stringName, moFillTypes[desc.index].fruitName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. " ".. moFillTypes[desc.index].fruitName;									
			else
				stringName = moFillTypes[desc.index].fruitName;
			end;								
		end;
	elseif fillTypeName ~= nil then		
		if not string.find(stringName, fillTypeName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. " ".. fillTypeName;									
			else
				stringName = fillTypeName;
			end;								
		end;
	else
		if not string.find(stringName, tostring(moLanguageXml:getTxt("unknow"))) then
			if string.len(stringName) > 0 then
				stringName = stringName.. " ".. tostring(moLanguageXml:getTxt("unknow"));									
			else
				stringName = tostring(moLanguageXml:getTxt("unknow"));
			end;								
		end;	
	end;	
	return pricePerLiter, stringName
end;

function getProductivityColor(self, productivity)
	local ratio =productivity;
	local color = moGuiMiniPdaSlots.warningColor0;
	if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
		color = moGuiMiniPdaSlots.warningColor1; --moGuiExtras.colors['greenDisabled'];
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		color = moGuiMiniPdaSlots.warningColor2; --moGuiExtras.colors['yellow'];
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
		color = moGuiMiniPdaSlots.warningColor3; --moGuiExtras.colors['red'];
	elseif tonumber(ratio) < 25 then
		color = moGuiMiniPdaSlots.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;
	return color;
end;

function getEggPrice(self, fillType)
	local bestPrice = 0;	
	local desc = Fillable.fillTypeIndexToDesc[fillType];	
	if desc ~= nil and moFillTypes[desc.index] ~= nil then		
		bestPrice = 1*moFillTypes[desc.index].pricePerLiter*moGeneralSettings.difficultyMultiplier;		
	end;
	return bestPrice;
end;

function getFruitPrice(self, fillType)	
	local bestPrice = 0;	
	local desc = Fillable.fillTypeIndexToDesc[fillType];	
	if desc ~= nil and moFillTypes[desc.index] ~= nil then		
		local bestPriceTemp = 1;
		if moFillTypes[desc.index].bestPrice ~= 0 then bestPriceTemp = moFillTypes[desc.index].bestPrice;end;
		bestPrice = moFillTypes[desc.index].pricePerLiter*bestPriceTemp*moGeneralSettings.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
		--print("money.............".. tostring(g_i18n:formatMoney(bestPrice)))
		--print("money.............".. tostring(string.format("%0.1f", Utils.getNoNil(bestPrice, 0))));
	end;
	return bestPrice;
end;

function getAnimalStorePrice(self, name)	
	local bestPrice = 0;	
	local storeItem = StoreItemsUtil.storeItemsByXMLFilename[name];
	if storeItem ~= nil then
		bestPrice = storeItem.price;
	end;
	return bestPrice;
end;

function getAnimalPrice(self, name)	
	local bestPrice = 0;	
	local desc = Fillable.fillTypeNameToDesc[name];
	if desc ~= nil and moFillTypes[desc.index] ~= nil then 
		local bestPriceTemp = 1;
		if moFillTypes[desc.index].bestPrice ~= 0 then bestPriceTemp = moFillTypes[desc.index].bestPrice;end;
		bestPrice = moFillTypes[desc.index].pricePerLiter/1000*bestPriceTemp*moGeneralSettings.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
	end;
	return bestPrice;
end;

function getWaterModFruitName(self, fillType)	
	local fruitName = tostring(moLanguageXml:getTxt("unknow"));	
	local desc = Fillable.fillTypeIndexToDesc[fillType];
	if desc ~= nil and moFillTypes[desc.index] ~= nil then 
		fruitName = string.lower(desc.name);		
	end;
	return fruitName;
end;